diff --git a/yum/__init__.py b/yum/__init__.py
index 99039e0..bf13f40 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -5260,42 +6770,84 @@ class YumBase(depsolve.Depsolve):
         except (IOError, OSError), e:
             self._ts_save_file = None
             if auto:
-                self.logger.critical(_("Could not save transaction file %s: %s") % (filename, str(e)))
+                self.logger.critical(_("Could not save transaction file %s: %s") % (filename, exception2msg(e)))
             else:
-                raise Errors.YumBaseError(_("Could not save transaction file %s: %s") % (filename, str(e)))
+                raise Errors.YumBaseError(_("Could not save transaction file %s: %s") % (filename, exception2msg(e)))
 
-        
-    def load_ts(self, filename, ignorerpm=None, ignoremissing=None):
-        """loads a transaction from a .yumtx file"""
+    def _load_ts_data(self, filename):
+        """ Load the file into a simple data format. """
+        try:
+            data = open(filename, 'r').readlines()
+        except (IOError, OSError), e:
+            return (exception2msg(e), None)
+
+        if not data:
+            return (_("File is empty."), None)
+
+        if data[0] == 'saved_tx:\n':
+            #  Old versions of yum would put "saved_tx:" at the beginning and
+            # two blank lines at the end when you used:
+            # "yum -q history addon-info saved_tx".
+            if data[-1] == 'history addon-info\n':
+                # Might as well also DTRT if they hand removed the plugins line
+                data = data[1:-3]
+            else:
+                data = data[1:-2]
+
+        return (None, data)
+        
+    def load_ts(self, filename, ignorerpm=None, ignoremissing=None,
+                ignorenewrpm=None):
+        """Load a transaction from a .yumtx file.
+
+        :param filename: the name of the file to load the transaction
+           from
+        :param ignorerpm: whether to ignore starting rpmdb version mismatch.
+        :param ignoremissing: whether to ignore that there may be
+           transaction members missing
+        :param ignorenewrpm: whether to ignore ending rpmdb version mismatch.
+        :return: the members of the loaded transaction
+        :raises: :class:`yum.Errors.YumBaseError` if there are problems
+           loading the transaction
+        """
         # check rpmversion - if not match throw a fit
         # check repoversions  (and repos)- if not match throw a fit
         # load each txmbr - if pkgs being updated don't exist, bail w/error
         # setup any ts flags
         # setup cmds for history/yumdb to know about
         # return txmbrs loaded
-        try:
-            data = open(filename, 'r').readlines()
-        except (IOError, OSError), e:
-            raise Errors.YumBaseError(_("Could not access/read saved transaction %s : %s") % (filename, str(e)))
-            
+
+        data = self._load_ts_data(filename)
+        if data[0] is not None:
+            raise Errors.YumBaseError(_("Could not access/read saved transaction %s : %s") % (filename, data[0]))
+        data = data[1]
 
         if ignorerpm is None:
             ignorerpm = self.conf.loadts_ignorerpm
+        if ignorenewrpm is None:
+            ignorenewrpm = self.conf.loadts_ignorenewrpm
         if ignoremissing is None:
             ignoremissing = self.conf.loadts_ignoremissing
+
+        #  Inherit this, because for the ending version to match the starting
+        # version must match.
+        if ignorerpm:
+            ignorenewrpm = True
             
         # data format
         # 0 == rpmdb version
         # 1 == tsflags
         # 2 == numrepos
         # 3:numrepos = repos
+        #  -- post 3.2.29 update: 'installed' repo. added with the values as the
+        #                         new rpmdb version.
         # 3+numrepos = num pkgs
         # 3+numrepos+1 -> EOF= txmembers
-        
+
         # rpm db ver
         rpmv = data[0].strip()
         if rpmv != str(self.rpmdb.simpleVersion(main_only=True)[0]):
-            msg = _("rpmdb ver mismatched saved transaction version, ")
+            msg = _("rpmdb ver mismatched saved transaction version,")
             if ignorerpm:
                 msg += _(" ignoring, as requested.")
                 self.logger.critical(_(msg))
@@ -5318,8 +6870,17 @@ class YumBase(depsolve.Depsolve):
         numrepos = int(data[2].strip())
         repos = []
         rindex=3+numrepos
+        future_rpmdbv = None
         for r in data[3:rindex]:
-            repos.append(r.strip().split(':'))
+            repo = r.strip().split(':')
+
+            if repo and repo[0] == 'installed':
+                #  This is an update hack to list the _future_ rpmdb version.
+                # Doing it this way allows older yum's to load newer ts files.
+                future_rpmdbv = "%s:%s" % (repo[1], repo[2])
+                continue
+
+            repos.append(repo)
 
         # pkgs/txmbrs
         numpkgs = int(data[rindex].strip())
@@ -5329,6 +6890,7 @@ class YumBase(depsolve.Depsolve):
         pkgcount = 0
         pkgprob = False
         curpkg = None
+        missingany = False
         for l in data[pkgstart:]:
             l = l.rstrip()
             # our main txmbrs
@@ -5356,6 +6918,7 @@ class YumBase(depsolve.Depsolve):
                     if not ignoremissing:
                         raise Errors.YumBaseError(msg)
                     else:
+                        ignorenewrpm = True
                         self.logger.critical(msg)
                 else:
                     pkgcount += 1
@@ -5432,12 +6995,18 @@ class YumBase(depsolve.Depsolve):
         if pkgprob:
             msg = _("Transaction members, relations are missing or ts has been modified,")
             if ignoremissing:
+                ignorenewrpm = True
                 msg += _(" ignoring, as requested. You must redepsolve!")
                 self.logger.critical(msg)
             else:
                 msg += _(" aborting.")
                 raise Errors.YumBaseError(msg)
             
+        if len(self.tsInfo) != pkgcount:
+            future_rpmdbv = None
+        if future_rpmdbv is not None:
+            self.tsInfo._check_future_rpmdbv = (pkgcount, future_rpmdbv,
+                                                ignorenewrpm)
         return self.tsInfo.getMembers()
 
     def _remove_old_deps(self):
@@ -5470,18 +7039,6 @@ class YumBase(depsolve.Depsolve):
                     if requiring == required: # if they are self-requiring skip them
                         continue
                         
-                # go through the stuff in the ts to be installed - make sure none of that needs the required pkg, either.
-                for (provn,provf,provevr) in required.provides:
-                    if self.tsInfo.getNewRequires(provn, provf, provevr).keys():
-                        still_needed = True
-                        okay_to_remove[required] = False
-                        break
-                for fn in required.filelist + required.dirlist:
-                    if self.tsInfo.getNewRequires(fn, None,(None,None,None)).keys():
-                        okay_to_remove[required] = False
-                        still_needed = True
-                        break
-                            
                     #for tbi_pkg in self.tsInfo.getMembersWithState(output_states=TS_INSTALL_STATES):
                     #   for reqtuple in tbi_pkg.po.requires:
                     #        if required.provides_for(reqtuple):
@@ -5533,7 +7090,24 @@ class YumBase(depsolve.Depsolve):
                     # Debugging output
                     self.verbose_logger.log(logginglevels.DEBUG_2, _("%s has revdep %s which was user-installed."), pkg, curpkg)
                     ok_to_remove[pkg] = False
+                    ok_to_remove[curpkg] = False
                     return True
+
+                #  Go through the stuff in the ts to be installed - make sure
+                # none of that needs the required pkg, either.
+                for (provn,provf,provevr) in curpkg.provides:
+                    if self.tsInfo.getNewRequires(provn, provf, provevr).keys():
+                        ok_to_remove[pkg] = False
+                        ok_to_remove[curpkg] = False
+                        self.verbose_logger.log(logginglevels.DEBUG_2, _("%s is needed by a package to be installed."), curpkg)
+                        return True
+                for fn in curpkg.filelist + curpkg.dirlist:
+                    if self.tsInfo.getNewRequires(fn, None,(None,None,None)).keys():
+                        ok_to_remove[pkg] = False
+                        ok_to_remove[curpkg] = False
+                        self.verbose_logger.log(logginglevels.DEBUG_2, _("%s is needed by a package to be installed."), curpkg)
+                        return True
+
                 visited[curpkg] = True
             all_leaves_visited = True
             leaves = curpkg.requiring_packages()
@@ -5547,4 +7121,3 @@ class YumBase(depsolve.Depsolve):
         # Debugging output
         self.verbose_logger.log(logginglevels.DEBUG_2, _("%s has no user-installed revdeps."), pkg)
         return False
-
diff --git a/yum/callbacks.py b/yum/callbacks.py
index 7ad25ce..a9a8e53 100644
--- a/yum/callbacks.py
+++ b/yum/callbacks.py
@@ -13,6 +13,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 
+"""Classes for handling various callbacks."""
+
 # imports
 
 import logging 
@@ -35,59 +37,79 @@ PT_MESSAGES = { PT_DOWNLOAD    : "Downloading Packages",
 
 
 class ProcessTransBaseCallback:
-    
+    """A class to handle callbacks from
+    :func:`YumBase.processTransaction`.
+    """
     def __init__(self):
         self.logger = logging.getLogger('yum.verbose.ProcessTrasactionBaseCallback')
         
     def event(self,state,data=None):
+        """Handle an event by logging it.
+
+        :param state: a number indicating the type of callback
+        :param data: data associated with the callback
+        """
         if state in PT_MESSAGES.keys():
             self.logger.info(PT_MESSAGES[state])
 
 class ProcessTransNoOutputCallback:
+    """A class to handle callbacks from
+    :func:`YumBase.processTransaction`, without logging them.
+    """
     def __init__(self):
         pass
          
     def event(self,state,data=None):
+        """Handle an event.
+
+        :param state: a number indicating the type of callback
+        :param data: data associated with the callback
+        """
         pass
     
 class DownloadBaseCallback( BaseMeter ):
-    """ 
-    This is class is a base class to use by implement a download progress
-    handler to be used with YumBase.repos.setProgressBar.
+    """This is a base class that can be extended to implement a custom
+    download progress handler to be used with
+    :func:`YumBase.repos.setProgressBar`.
     
-    Example:
-    
-    from yum.callbacks import DownloadBaseCallback
-    
-    class MyDownloadCallback(  DownloadBaseCallback ):
-
-        def updateProgress(self,name,frac,fread,ftime):
-            '''
-            Update the progressbar
-            @param name: filename
-            @param frac: Progress fracment (0 -> 1)
-            @param fread: formated string containing BytesRead
-            @param ftime : formated string containing remaining or elapsed time
-            '''
-            pct = int( frac*100 )
-            print " %s : %s " % (name,pct)
-
-
-    if __name__ == '__main__':
-        my = YumBase()
-        my.doConfigSetup()
-        dnlcb = MyDownloadCallback()
-        my.repos.repos.setProgressBar( dnlcb )
-        for pkg in my.pkgSack:
-            print pkg.name
-
-    """
+    Example::
     
+       from yum.callbacks import DownloadBaseCallback
+       
+       class MyDownloadCallback(  DownloadBaseCallback ):
+   
+           def updateProgress(self,name,frac,fread,ftime):
+               '''
+               Update the progressbar
+               @param name: filename
+               @param frac: Progress fracment (0 -> 1)
+               @param fread: formated string containing BytesRead
+               @param ftime : formated string containing remaining or elapsed time
+               '''
+               pct = int( frac*100 )
+               print " %s : %s " % (name,pct)
+   
+   
+       if __name__ == '__main__':
+           my = YumBase()
+           my.doConfigSetup()
+           dnlcb = MyDownloadCallback()
+           my.repos.setProgressBar( dnlcb )
+           for pkg in my.pkgSack:
+               print pkg.name
+       """
     def __init__(self):
         BaseMeter.__init__( self )
         self.totSize = ""   # Total size to download in a formatted string (Kb, MB etc)
         
     def update( self, amount_read, now=None ):
+        """Update the status bar.
+
+        :param amount_read: the amount of data, in bytes, that has been read
+        :param now: the current time in seconds since the epoch.  If
+           *now* is not given, the output of :func:`time.time()` will
+           be used.
+        """
         BaseMeter.update( self, amount_read, now )
 
     def _do_start( self, now=None ):
@@ -130,12 +152,15 @@ class DownloadBaseCallback( BaseMeter ):
         return name
 
     def updateProgress(self,name,frac,fread,ftime):
-        '''
-         Update the progressbar (Overload in child class)
-        @param name: filename
-        @param frac: Progress fracment (0 -> 1)
-        @param fread: formated string containing BytesRead
-        @param ftime : formated string containing remaining or elapsed time
-        '''
+        """Update the progressbar.  This method should be overridden
+        by subclasses to implement the handler.
+
+        :param name: the name of the filed being downloaded
+        :param frac: number between 0 and 1 representing the fraction
+            fraction of the file that has been downloaded
+        :param fread: formatted string containing the number of bytes read
+        :param ftime: formatted string containing remaining or elapsed time
+
+        """
         pass
         
diff --git a/yum/comps.py b/yum/comps.py
index 65f6d5e..92e87ba 100755
--- a/yum/comps.py
+++ b/yum/comps.py
@@ -16,14 +16,14 @@
 
 import types
 import sys
-from constants import *
-from Errors import CompsException
+from yum.constants import *
+from yum.Errors import CompsException
 #FIXME - compsexception isn't caught ANYWHERE so it's pointless to raise it
 # switch all compsexceptions to grouperrors after api break
 import fnmatch
 import re
 from yum.i18n import to_unicode
-from misc import get_my_lang_code
+from yum.misc import get_my_lang_code
 from yum.misc import cElementTree_iterparse as iterparse 
 
 lang_attr = '{http://www.w3.org/XML/1998/namespace}lang'
@@ -43,6 +43,16 @@ class CompsObj(object):
         return self.name
 
     @property
+    def compsid(self):
+        """ Return the "id": categoryid, groupid, environmentid. """
+
+        for idT in ('categoryid', 'groupid', 'environmentid'):
+            if hasattr(self, idT):
+                return getattr(self, idT)
+
+        return None
+
+    @property
     def ui_name(self):
         """ Return the "name" of the object for the current locale. """
         return self.nameByLang(get_my_lang_code())
@@ -108,12 +118,14 @@ class Group(CompsObj):
         self.optional_packages = {}
         self.default_packages = {}
         self.conditional_packages = {}
-        self.langonly = None ## what the hell is this?
+        self.langonly = None
         self.groupid = None
         self.display_order = 1024
         self.installed = False
         self.toremove = False
 
+        self._weak = False
+
         if elem:
             self.parse(elem)
 
@@ -191,6 +203,10 @@ class Group(CompsObj):
                     continue
 
                 package = child.text
+                if not package:
+                    #  Ignore this too, or we end up doing:
+                    # .searchNevra(name=None)
+                    continue
                 if genre == 'mandatory':
                     self.mandatory_packages[package] = 1
                 elif genre == 'default':
@@ -271,6 +287,157 @@ class Group(CompsObj):
 
         return msg      
 
+class Environment(CompsObj):
+    """ Environment object parsed from group data in each repo, and merged """
+
+    def __init__(self, elem=None):
+        self.name = ""
+        self.environmentid = None
+        self.description = ""
+        self.translated_name = {}
+        self.translated_description = {}
+        self.display_order = 1024
+        self.langonly = None
+        self.installed = False
+        self._groups = {}
+        self._options = {}
+        self._defaultoptions = {}
+
+        self._weak = False
+
+        if elem:
+            self.parse(elem)
+
+    def _allgroupiter(self):
+        lst = self._groups.keys() + \
+              self._options.keys()
+        return lst
+
+    allgroups = property(_allgroupiter)
+
+    def _groupiter(self):
+        return self._groups.keys()
+
+    groups = property(_groupiter)
+
+    def _optioniter(self):
+        return self._options.keys()
+
+    options = property(_optioniter)
+
+    def _defaultoptioniter(self):
+        return self._defaultoptions.keys()
+
+    defaultoptions = property(_defaultoptioniter)
+
+    def parse(self, elem):
+        for child in elem:
+            if child.tag == 'id':
+                myid = child.text
+                if self.environmentid is not None:
+                    raise CompsException
+                self.environmentid = myid
+
+            elif child.tag == 'name':
+                text = child.text
+                if text:
+                    text = text.encode('utf8')
+
+                lang = child.attrib.get(lang_attr)
+                if lang:
+                    self.translated_name[lang] = text
+                else:
+                    self.name = text
+
+            elif child.tag == 'description':
+                text = child.text
+                if text:
+                    text = text.encode('utf8')
+
+                lang = child.attrib.get(lang_attr)
+                if lang:
+                    self.translated_description[lang] = text
+                else:
+                    self.description = text
+
+            elif child.tag == 'grouplist':
+                self.parse_group_list(child)
+
+            elif child.tag == 'optionlist':
+                self.parse_option_list(child)
+
+            elif child.tag == 'display_order':
+                self.display_order = parse_number(child.text)
+
+    def parse_group_list(self, grouplist_elem):
+        for child in grouplist_elem:
+            if child.tag == 'groupid':
+                groupid = child.text
+                self._groups[groupid] = 1
+
+    def parse_option_list(self, optionlist_elem):
+        for child in optionlist_elem:
+            if child.tag == 'groupid':
+                optionid = child.text
+                self._options[optionid] = 1
+                defopt = child.attrib.get('default')
+                if defopt:
+                    default = parse_boolean(defopt)
+                else:
+                    default = False
+                if default:
+                    self._defaultoptions[optionid] = 1
+
+    def add(self, obj):
+        """Add another environment object to this object"""
+
+        for grp in obj.groups:
+            self._groups[grp] = 1
+
+        for grp in obj.defaultoptions:
+            self._defaultoptions[grp] = 1
+
+        for grp in obj.options:
+            self._options[grp] = 1
+
+        # name and description translations
+        for lang in obj.translated_name:
+            if lang not in self.translated_name:
+                self.translated_name[lang] = obj.translated_name[lang]
+
+        for lang in obj.translated_description:
+            if lang not in self.translated_description:
+                self.translated_description[lang] = obj.translated_description[lang]
+
+    def xml(self):
+        """write out an xml stanza for the environment object"""
+        msg ="""
+  <environment>
+   <id>%s</id>
+   <display_order>%s</display_order>\n""" % (self.environmentid, self.display_order)
+
+        msg +="""   <name>%s</name>\n""" % self.name
+        for (lang, val) in self.translated_name.items():
+            msg += """   <name xml:lang="%s">%s</name>\n""" % (lang, val)
+
+        msg += """   <description>%s</description>\n""" % self.description
+        for (lang, val) in self.translated_description.items():
+            msg += """    <description xml:lang="%s">%s</description>\n""" % (lang, val)
+
+        msg += """    <grouplist>\n"""
+        for grp in self.groups:
+            msg += """     <groupid>%s</groupid>\n""" % grp
+        msg += """    </grouplist>\n"""
+        msg += """    <optionlist>\n"""
+        for grp in self.options:
+            if grp in self.defaultoptions:
+                msg += """     <groupid default="true">%s</groupid>\n""" % grp
+            else:
+                msg += """     <groupid>%s</groupid>\n""" % grp
+        msg += """    </optionlist>\n"""
+        msg += """  </environment>\n"""
+
+        return msg
 
 class Category(CompsObj):
     """ Category object parsed from group data in each repo. and merged. """
@@ -371,12 +538,61 @@ class Category(CompsObj):
         msg += """  </category>\n"""
 
         return msg                
-        
+
+class Langpacks(CompsObj):
+    def __init__(self, elem=None):
+        self.langpacks = []
+        self.name = "" # prevent CompsObj.__str__() throwing an AttributeError
+        if elem is not None:
+            self.parse(elem)
+
+    def __getitem__(self, indx):
+        return self.langpacks[indx]
+
+    def __iter__(self):
+        for i in self.langpacks:
+            yield i
+
+    def __len__(self):
+        return len(self.langpacks)
+
+    def add(self, name, install):
+        langpack = {
+            "name": name,
+            "install": install,
+        }
+        self.langpacks.append(langpack)
+
+    def parse(self, elem):
+        for child in elem:
+            if child.tag == "match":
+                langpack = {
+                    "name": child.attrib.get("name"),
+                    "install": child.attrib.get("install"),
+                }
+                self.langpacks.append(langpack)
+            else:
+                raise CompsException("Unexpected element in <langpacks>: %s" % child.tag)
+
+        self.name = elem.attrib.get("name")
+        self.install = elem.attrib.get("install")
+
+    def xml(self):
+        """write out an xml stanza for the Langpacks object"""
+        if not self.langpacks:
+            return ''
+        msg  = '  <langpacks>\n'
+        for i in self:
+            msg += '    <match name="%s" install="%s"/>\n' % (i["name"], i["install"])
+        msg += '  </langpacks>\n'
+        return msg
 
 class Comps(object):
     def __init__(self, overwrite_groups=False):
         self._groups = {}
+        self._environments = {}
         self._categories = {}
+        self._langpacks = Langpacks()
         self.compscount = 0
         self.overwrite_groups = overwrite_groups
         self.compiled = False # have groups been compiled into avail/installed 
@@ -387,14 +603,24 @@ class Comps(object):
         grps = self._groups.values()
         grps.sort(key=lambda x: (x.display_order, x.name))
         return grps
-        
+
+    def get_environments(self):
+        environments = self._environments.values()
+        environments.sort(key=lambda x: (x.display_order, x.name))
+        return environments
+
     def get_categories(self):
         cats = self._categories.values()
         cats.sort(key=lambda x: (x.display_order, x.name))
         return cats
+
+    def get_langpacks(self):
+        return self._langpacks
     
     groups = property(get_groups)
+    environments = property(get_environments)
     categories = property(get_categories)
+    langpacks = property(get_langpacks)
     
     def has_group(self, grpid):
         exists = self.return_groups(grpid)
@@ -416,6 +642,9 @@ class Comps(object):
         """return all groups which match either by glob or exact match"""
         returns = {}
 
+        if not group_pattern:
+            return []
+
         for item in group_pattern.split(','):
             item = item.strip()
             if item in self._groups:
@@ -447,6 +676,60 @@ class Comps(object):
 
         return returns.values()
 
+    def has_environment(self, environmentid):
+        exists = self.return_environments(environmentid)
+
+        if exists:
+            return True
+
+        return False
+
+    def return_environment(self, environmentid):
+        """Return the first group which matches"""
+        environments = self.return_environments(environmentid)
+        if environments:
+            return environments[0]
+
+        return None
+
+    def return_environments(self, env_pattern, case_sensitive=False):
+        """return all environments which match either by glob or exact match"""
+        returns = {}
+
+        if not env_pattern:
+            return []
+
+        for item in env_pattern.split(','):
+            item = item.strip()
+            if item in self._environments:
+                env = self._environments[item]
+                returns[env.environmentid] = env
+                continue
+
+            if case_sensitive:
+                match = re.compile(fnmatch.translate(item)).match
+            else:
+                match = re.compile(fnmatch.translate(item), flags=re.I).match
+
+            done = False
+            for env in self.environments:
+                for name in env.name, env.environmentid, env.ui_name:
+                    if match(name):
+                        done = True
+                        returns[env.environmentid] = env
+                        break
+            if done:
+                continue
+
+            # If we didn't match to anything in the current locale, try others
+            for env in self.environments:
+                for name in env.translated_name.values():
+                    if match(name):
+                        returns[env.environmentid] = env
+                        break
+
+        return returns.values()
+
     #  This is close to returnPackages() etc. API ... need to std. these names
     # the above return_groups uses different, but equal, API.
     def return_categories(self, pattern, ignore_case=True):
@@ -486,10 +769,27 @@ class Comps(object):
     def add_group(self, group):
         if group.groupid in self._groups:
             thatgroup = self._groups[group.groupid]
+            if thatgroup._weak:
+                # If what we had was weak, use this one and merge the weak one.
+                tmp = group
+                group = thatgroup
+                thatgroup = self._groups[group.groupid] = tmp
             thatgroup.add(group)
         else:
             self._groups[group.groupid] = group
 
+    def add_environment(self, environment):
+        if environment.environmentid in self._environments:
+            env = self._environments[environment.environmentid]
+            if env._weak:
+                # If what we had was weak, use this one and merge the weak one.
+                tmp = environment
+                environment = env
+                env = self._environments[environment.environmentid] = tmp
+            env.add(environment)
+        else:
+            self._environments[environment.environmentid] = environment
+
     def add_category(self, category):
         if category.categoryid in self._categories:
             thatcat = self._categories[category.categoryid]
@@ -497,6 +797,9 @@ class Comps(object):
         else:
             self._categories[category.categoryid] = category
 
+    def add_langpack(self, name, install):
+        self._langpacks.add(name, install)
+
     def add(self, srcfile = None):
         if not srcfile:
             raise CompsException
@@ -520,9 +823,14 @@ class Comps(object):
                 if elem.tag == "group":
                     group = Group(elem)
                     self.add_group(group)
+                if elem.tag == "environment":
+                    environment = Environment(elem)
+                    self.add_environment(environment)
                 if elem.tag == "category":
                     category = Category(elem)
                     self.add_category(category)
+                if elem.tag == "langpacks":
+                    self._langpacks.parse(elem)
         except SyntaxError, e:
             raise CompsException, "comps file is empty/damaged"
             
@@ -557,13 +865,32 @@ class Comps(object):
                     if pkgname in inst_pkg_names:
                         group.installed = True
                         break
+
+        # Now do basically the same thing for evgroups.
+        inst_grp_names = {}
+        for group in self.groups:
+            inst_grp_names[group.groupid] = group.installed
+        for evgroup in self.environments:
+            if evgroup.groups:
+                evgroup.installed = True
+                for grpname in evgroup.groups:
+                    if not inst_grp_names.get(grpname):
+                        evgroup.installed = False
+                        break
+            else:
+                evgroup.installed = False
+                for grpname in evgroup.options:
+                    if grpname in inst_grp_names:
+                        evgroup.installed = True
+                        break
         
         self.compiled = True
     
     def xml(self):
         """returns the xml of the comps files in this class, merged"""
 
-        if not self._groups and not self._categories:
+        if not self._groups and not self._categories and \
+            not self._environments and not len(self._langpacks):
             return ""
             
         msg = """<?xml version="1.0" encoding="UTF-8"?>
@@ -575,7 +902,9 @@ class Comps(object):
             msg += g.xml()
         for c in self.get_categories():
             msg += c.xml()
-
+        for e in self.get_environments():
+            msg += e.xml()
+        msg += self.get_langpacks().xml()
         msg += """\n</comps>\n"""
         
         return msg
@@ -590,16 +919,34 @@ def main():
         for srcfile in sys.argv[1:]:
             p.add(srcfile)
 
+        print
+        print "===== GROUPS ====="
         for group in p.groups:
-            print group
+            print "%s (id: %s)" % (group, group.groupid)
             for pkg in group.packages:
                 print '  ' + pkg
-        
+
+        print
+        print "===== ENVIRONMENTS ====="
+        for environment in p.environments:
+            print "%s (id: %s)" % (environment.name, environment.environmentid)
+            for group in environment.groups:
+                print '  ' + group
+            for group in environment.options:
+                print '  *' + group
+
+        print
+        print "===== CATEGORIES ====="
         for category in p.categories:
-            print category.name
+            print "%s (id: %s)" % (category.name, category.categoryid)
             for group in category.groups:
                 print '  ' + group
-                
+
+        print
+        print "===== LANGPACKS ====="
+        for langpack in p.langpacks:
+            print '  %s (%s)' % (langpack["name"], langpack["install"])
+
     except IOError:
         print >> sys.stderr, "newcomps.py: No such file:\'%s\'" % sys.argv[1]
         sys.exit(1)
